/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ClientSocket.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_ClientSocket_H
#define OpenSOAP_ClientSocket_H

#include <OpenSOAP/ByteArray.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPClientSocket OpenSOAPClientSocket;
    typedef OpenSOAPClientSocket    *OpenSOAPClientSocketPtr;

    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketCreate(OpenSOAPClientSocketPtr * /* [out] */ s);
    
    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketRelease(OpenSOAPClientSocketPtr /* [in] */ s);
    
    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketOpen(OpenSOAPClientSocketPtr /* [in] */ s,
                             const char * /* [in] */ node,
                             const char * /* [in] */ service);
    
    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketClose(OpenSOAPClientSocketPtr /* [in] */ s);
    
    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketRead(OpenSOAPClientSocketPtr /* [in] */ s,
                             unsigned char * /* [out] */ buf,
                             size_t * /* [in, out] */ buf_sz);
    
    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketWrite(OpenSOAPClientSocketPtr /* [in] */ s,
                              const unsigned char * /* [in] */ buf,
                              size_t * /* [in, out] */ buf_sz);
    
    extern
    int
    OPENSOAP_API
    OpenSOAPClientSocketReadToDelm(OpenSOAPClientSocketPtr /* [in] */ s,
                                   const unsigned char * /* [in] */ delm,
                                   size_t /* [in] */ delm_sz,
                                   OpenSOAPByteArrayPtr /* [out] */ buf);

#if 0    
    int
    OPENSOAP_API
    OpenSOAPClientSocketReadWithSize(OpenSOAPClientSocketPtr
                                     /* [in] */ s,
                                     size_t /* [in] */ sz,
                                     OpenSOAPByteArrayPtr
                                     /* [out] */ buf);
#endif
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_ClientSocket_H */
