/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Service.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_Service_H
#define OpenSOAP_Service_H

#include <OpenSOAP/Envelope.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPService OpenSOAPService;
    typedef OpenSOAPService    *OpenSOAPServicePtr;

    typedef
    int
    (*OpenSOAPServiceFuncPtr)(OpenSOAPEnvelopePtr /* [in] */ request,
                              OpenSOAPEnvelopePtr * /* [out] */ response,
                              void * /* [in, out] */ opt);

    int
    OPENSOAP_API
    OpenSOAPServiceCreateMB(OpenSOAPServicePtr * /* [out] */ srv,
                            const char * /* [in] */ srv_name,
                            const char * /* [in] */ connect_type,
                            int /* [in] */ is_loop,
                            ...);

    int
    OPENSOAP_API
    OpenSOAPServiceCreateWC(OpenSOAPServicePtr * /* [out] */ srv,
                            const wchar_t * /* [in] */ srv_name,
                            const char * /* [in] */ connect_type,
                            int /* [in] */ is_loop,
                            ...);

    int
    OPENSOAP_API
    OpenSOAPServiceRelease(OpenSOAPServicePtr /* [in, out] */ srv);
    
    int
    OPENSOAP_API
    OpenSOAPServiceRegisterMB(OpenSOAPServicePtr /* [in, out] */ srv,
                              const char * /* [in] */ name,
                              OpenSOAPServiceFuncPtr /* [in] */ func,
                              void * /* [in] */ opt);

    int
    OPENSOAP_API
    OpenSOAPServiceRegisterWC(OpenSOAPServicePtr /* [in, out] */ srv,
                              const wchar_t * /* [in] */ name,
                              OpenSOAPServiceFuncPtr /* [in] */ func,
                              void * /* [in] */ opt);

    int
    OPENSOAP_API
    OpenSOAPServiceRun(OpenSOAPServicePtr /* [in, out] */ srv);
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_Service_H */
