/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SSMLInfo.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <iostream>
#include "SSMLInfo.h"

using namespace OpenSOAP;

SSMLInfo::SSMLInfo()
{
  _syncTTL = 0;
  _asyncTTL = 0;
}

const std::string& 
SSMLInfo::getOperationName() const
{
  return _operationName;
}

void 
SSMLInfo::setOperationName(const std::string& operationName)
{
  _operationName = operationName;
}


void 
SSMLInfo::setOperationType(const std::string& operationType)
{
  _operationType = operationType;
}

const std::string& 
SSMLInfo::getOperationType() const
{
  return _operationType;
}

const std::string& 
SSMLInfo::getExecProg() const
{
  return _execProg;
}

void 
SSMLInfo::setExecProg(const std::string& execProg)
{
  _execProg = execProg;
}

bool 
SSMLInfo::getIsSync() const
{
  return _isSync;
}

void 
SSMLInfo::setIsSync(const bool isSync)
{
  _isSync = isSync;
}

unsigned int 
SSMLInfo::getSyncTTL() const
{
  return _syncTTL;
}

void 
SSMLInfo::setSyncTTL(const unsigned int ttl)
{
  _syncTTL = ttl;
}

unsigned int 
SSMLInfo::getAsyncTTL() const
{
  return _asyncTTL;
}

void 
SSMLInfo::setAsyncTTL(const unsigned int ttl)
{
  _asyncTTL = ttl;
}


const std::string& 
SSMLInfo::getTTLCount() const
{
  return _ttlCount;
}

bool 
SSMLInfo::setTTLCount(const std::string& ttlCount)
{
  _ttlCount = ttlCount;
  return true;
}

const std::string& 
SSMLInfo::getConnectionMethod() const
{
  return _connectionMethod;
}

bool 
SSMLInfo::setConnectionMethod(const std::string& connectionMethod)
{
  _connectionMethod = connectionMethod;
  return true;
}

const std::string& 
SSMLInfo::getSendFIFOName() const
{
  return _sendFIFOName;
}

void 
SSMLInfo::setSendFIFOName(const std::string& sendFIFOName)
{
  _sendFIFOName = sendFIFOName;
}

const std::string& 
SSMLInfo::getRecvFIFOName() const
{
  return _recvFIFOName;
}

void 
SSMLInfo::setRecvFIFOName(const std::string& recvFIFOName)
{
  _recvFIFOName = recvFIFOName;
}


const std::string& 
SSMLInfo::getHostname() const
{
  return _hostname;
}

void 
SSMLInfo::setHostname(const std::string& hostname)
{
  _hostname = hostname;
}


unsigned int 
SSMLInfo::getPort() const
{
  return _port;
}


void 
SSMLInfo::setPort(const unsigned int port)
{
  _port = port;
}

