/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ServerCommon.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef _ServerCommon_H_
#define _ServerCommon_H_

#include <string>

namespace OpenSOAP {

  // for LOG
  static const std::string TAG_ERR = "*** E ***:";
  static const std::string TAG_WRN = "*** W ***:";
  static const std::string TAG_INF = "*** I ***:";

  //keyword
  //static const std::string FILE_PATH_DELMIT = "/";
  static const char FILE_PATH_DELMIT = '/';

  //-------------------------------------------
  //ʊ֐
  //lbg[Nread/writeC^[tF[X(Socket/FIFO)
  int read(int aFd, std::string& aData);
  int write(int aFd, const std::string& aData);
  //-------------------------------------------

#if 1
  //temp.
  static const std::string MSGDRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/MsgDrv";
  static const std::string SYNC_SRVDRV_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/SyncSrvDrv";
  static const std::string ASYNC_SRVDRV_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/AsyncSrvDrv";
  static const std::string SRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/Srv";
  static const std::string FIFOSRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/FIFOSrv";
  static const std::string FWDER_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/Fwder";
  static const std::string IDMGR_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/IdManager";
  static const std::string SSMLATTRMGR_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/SSMLAttrMgr";
  static const std::string SRVCONFATTRMGR_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/SrvConfAttrMgr";
   static const std::string FWDQUEUE_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/FwdQueue";
  static const std::string REQQUEUE_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/ReqQueue";
  static const std::string RESSPOOL_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/ResSpool";
  static const std::string TTLTABLE_SOCKET_ADDR 
  = "/var/tmp/OpenSOAP/SOCKET/TTLTable";
#else
  //temp.
  static const std::string MSGDRV_SOCKET_ADDR; //="/var/tmp/OpenSOAP/SOCKET/MsgDrv";
  static const std::string SRVDRV_SOCKET_ADDR; //="/var/tmp/OpenSOAP/SOCKET/SrvDrv";
  static const std::string IDMGR_SOCKET_ADDR; 
  //="/var/tmp/OpenSOAP/SOCKET/IdManager";
#endif

} // end of namespace OpenSOAP


#endif _ServerCommon_H_
