/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: StringUtil.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef StringUtil_toString_H
#define StringUtil_toString_H

#include <string>
#ifdef SSTREAM_DEFINED
#include <sstream>
#else
#include <strstream.h>
#endif /* SSTREAM_DEFINED */

namespace StringUtil {
    template <typename SrcType>
    std::string
    toString(const SrcType &src) {
#ifdef SSTREAM_DEFINED
        std::ostringstream    ost;
	ost
            <<  src;
#else
        ostrstream  ost;
        ost
            <<  src
            <<  /* std:: */ends; 
#endif /* SSTREAM_DEFINED */        

        return ost.str();
        
    }
}

#endif  /* StringUtil_toString_H */
